

import static org.junit.Assert.*;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class PhoneBookTest
{

    @Before
    public void setUp(){ 
        PhoneBook pb = new PhoneBook(); 
    }
    
    @Test
    public void testAdd1(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 456";
        
        pb.addEntrant("John" , "123", "456");
        String actual = pb.lookup("John");
        
        assertEquals(expected, actual);
    }
    
    @Test
    public void testAdd2(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123";
        
        pb.addEntrant("Josh" , "123");
        String actual = pb.lookup("Josh");
        
        assertEquals(expected, actual);
    }
    
    
    @Test
    public void testRemove(){
        PhoneBook pb = new PhoneBook();
        
        String expected = null;
        
        pb.addEntrant("Josh" , "123");
        pb.removeEntrant("Josh");
        String actual = pb.lookup("Josh");
        
        assertEquals(expected, actual);
        
    }
    
    @Test
    public void testLookup(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 456, 789";
        
        pb.addEntrant("Josh" , "123", "456", "789");
        String actual = pb.lookup("Josh");
        
        assertEquals(expected, actual);
    }
    
    @Test
    public void testReverseLookup1(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "Joe";
        
        pb.addEntrant("Josh" , "123", "456", "789");
        pb.addEntrant("John" , "321", "654", "987");
        pb.addEntrant("Joe" , "111", "222", "333");
        
        String actual = pb.reverseLookup("222");
        
        assertEquals(expected, actual);
    }
    
    @Test
    public void testReverseLookup2(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "John";
        
        pb.addEntrant("Josh" , "123", "456", "789");
        pb.addEntrant("John" , "321", "654", "987");
        pb.addEntrant("Joe" , "111", "222", "333");
        
        String actual = pb.reverseLookup("654");
        
        assertEquals(expected, actual);
    }
    
    @Test
    public void testAddNumber1(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 456";
        
        pb.addEntrant("Josh" , "123");
        pb.addNumber("Josh","456");
        
        String actual = pb.lookup("Josh");
        assertEquals(expected, actual);
    }
    
    @Test
    public void testAddNumber2(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 456, 789";
        
        pb.addEntrant("Jim" , "123");
        pb.addNumber("Jim","456");
        pb.addNumber("Jim","789");
        
        String actual = pb.lookup("Jim");
        assertEquals(expected, actual);
    }
    
    @Test
    public void testRemoveNumber1(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 456";
        
        pb.addEntrant("Jim" , "123", "456", "789");
        pb.removeNumber("Jim", "789");
        
        String actual = pb.lookup("Jim");
        assertEquals(expected, actual);
    }
    
    @Test
    public void testRemoveNumber2(){
        PhoneBook pb = new PhoneBook();
        
        String expected = "123, 789";
        
        pb.addEntrant("Jim" , "123", "456", "789");
        pb.removeNumber("Jim", "456");
        
        String actual = pb.lookup("Jim");
        assertEquals(expected, actual);
    }
    
    
    
}
